/* 
 * File:   rele2.c
 * Author: Pavel
 *
 * Created on 26. kvtna 2016, 14:28
 */

// _FOSC0_INT & _CLKOUTEN_OFF & _PWRTE_ON & _WDTE_OFF & _CP_OFF & _WRT_OFF &_MCLRE_ON & _BOREN_DIS
//	__idlocs	0x1234

#pragma   config FOSC0 = INT,  CLKOUTEN = OFF,   MCLRE = OFF
#pragma   config PWRTE = ON, BOREN = DIS
#pragma   config  WDTE = OFF
#pragma   config  WRT = OFF
#pragma   config  CP = OFF
//#pragma   config   CPD = OFF
// #pragma   config  WRTE = OFF
// #pragma   config  WRTB = OFF, WRTC = OFF, WRTD = OFF
//#pragma   config  EBTR0 = OFF, EBTR1 = OFF
//#pragma   config  EBTRB = OFF

#include <stdio.h>
#include <stdlib.h>
#include <xc.h>
/*
static const char sin[] = {

    16, 17, 19, 20, 21, 23, 24, 25, 26, 27, 28, 29, 30, 30, 31, 31,
    31, 31, 31, 30, 30, 29, 28, 27, 26, 25, 24, 23, 21, 20, 19, 17,
    15, 14, 12, 11, 10,  8,  7,  6,  5,  4,  3,  2,  1,  1,  0,  0,
     0,  0,  0,  1,  1,  2,  3,  4,  5,  6,  7,  8, 10, 11, 12, 14
};
*//*
static const char sin[] = {
 16, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 25, 26, 27, 27, 28, 29, 29, 30, 30, 
 30, 31, 31, 31, 31, 31, 31, 31, 31, 31, 30, 30, 30, 29, 29, 28, 27, 27, 26, 25, 
 25, 24, 23, 22, 21, 20, 19, 18, 17, 16, 15, 15, 14, 13, 12, 11, 10,  9,  8,  7,  
  6,  6,  5,  4,  4,  3,  2,  2,  1,  1,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  
  1,  1,  1,  2,  2,  3,  4,  4,  5,  6,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15
};
 */ 
static const char sin[] = {
 16,  17,  19,  21,  23,  25,  26,  27,  29,  30,  30,  31,  31,  
 31,  31,  30,  30,  29,  27,  26,  25,  23,  21,  19,  17,  15,  
 14,  12,  10,   8,   6,   5,   4,   2,   1,   1,   0,   0,   0,   
 0,   1,   1,   2,   4,   5,   6,   8,  10,  12,  14
};  
/*
 * 
 */
char sinp = 0;
char rele = 0;
char usb = 0;
char data = 0;
char stat = 0; 

void Sdelay(int dl) {
    int td = dl;
    while (td) {
        _delay(12 * 40);
        td--;
    }
}

void interrupt INTSR(void) {

    if (TMR2IF) {
        TMR2IF = 0;

        //  if(sinus) {
        //  if(sinp>=64)sinp=0;
        DACCON1 = sin[sinp];
        sinp++;
      
        if(sinp>49)sinp=0;
        // }

    }
    if (TMR1GIF) {
        TMR1GIF = 0;
        data = TMR1L;
        TMR1 = 0;
    }
}

void Rele(char rele){
            TRISAbits.TRISA1 = 1;
            TRISAbits.TRISA4 = 1;
            stat = PORTA;
     if (rele == 1){ 
       // if(stat & 0x10 == 0){
            TRISAbits.TRISA1 = 0;
            TRISAbits.TRISA4 = 0;
            PORTAbits.RA1 = 1;
            PORTAbits.RA4 = 0;
            Sdelay(10);
            PORTAbits.RA4 = 1;
          
            Sdelay(5);
      //  };
            TRISAbits.TRISA1 = 1;
            TRISAbits.TRISA4 = 1;
        //
        } else /*if (rele == 0)*/{
           //    if(stat & 0x10) {
            TRISAbits.TRISA1 = 0;
            TRISAbits.TRISA4 = 0;
            PORTAbits.RA1 = 0;
            PORTAbits.RA4 = 1;
            Sdelay(10);
            PORTAbits.RA1 = 1;
            PORTAbits.RA4 = 1;
            Sdelay(5);
          //    };
            TRISAbits.TRISA1 = 1;
            TRISAbits.TRISA4 = 1;
        }
}


void main() {




    PORTA = 0;
    LATA = 0;
    TRISA = 0x3F;

    TRISAbits.TRISA2 = 0;
    //  TRISAbits.TRISA4 = 1;

    ANSELA = 1;
    OSCCON = 0x30;
    // APFCON = 1;
    T1GSEL = 1; //gate RA3
    T1CON = 0x85;
    T1GCON = 0x80;
    DACCON0 = 0xE0;
    DACCON1 = 0;
    DACRNG = 0;

    PR2 = 99;


    T2CON = 0;
    TMR2IE = 0;
    TMR2 = 0;
    TMR1 = 0;

    TMR1GIE = 1;
    TMR1GIF = 0;
    PEIE = 1;
    GIE = 1;

    TMR2ON = 1;
    TMR2IE = 1;

    //  data=1;
    while (1) {
        if (data) {
            switch (data) {
                case 1: TMR2ON = 1;
                    TMR2IE = 1;
                    break;
                case 2: TMR2ON = 0;
                    TMR2IE = 0;
                    DACCON1 = 0;
                    break;
                case 3: PORTAbits.RA2 = 1; //usb
                    break;
                case 4: PORTAbits.RA2 = 0; // !usb 
                    break;
                case 5: Rele(1);
                    break;
                case 6: Rele(0);
                    break;
                case 7: DACRNG = 0; //160 mV
                    break;
                case 8: DACRNG = 1; //5 V  
                default: if (data >= 10) {
                        TMR2ON = 0;
                        TMR2IE = 0;
                        DACCON1 = (data - 10);
                    }
                    break;

            }
            data = 0;
      //  }




/*
       // Sdelay(10);
        if (rele == 1){ 
        //if(PORTAbits.RA1 == 0){
            TRISAbits.TRISA1 = 0;
            TRISAbits.TRISA4 = 0;
            PORTAbits.RA1 = 1;
            PORTAbits.RA4 = 0;
            Sdelay(10);
            PORTAbits.RA1 = 0;
            Sdelay(5);
            TRISAbits.TRISA1 = 1;
            TRISAbits.TRISA4 = 1;
        //};
        } else if (rele == 0){
              //  if( PORTAbits.RA1 == 1) {
            TRISAbits.TRISA1 = 0;
            TRISAbits.TRISA4 = 0;
            PORTAbits.RA1 = 0;
            PORTAbits.RA4 = 1;
            Sdelay(10);
            PORTAbits.RA1 = 1;
            Sdelay(5);

            TRISAbits.TRISA1 = 1;
            TRISAbits.TRISA4 = 1;
             //   };
        }
            */
        }
    }//while

   // return (EXIT_SUCCESS);
}

